Package org.mozilla.javascript.dtoa

## Class DoubleFormatter

- java.lang.Object
- - org.mozilla.javascript.dtoa.DoubleFormatter

-     public class DoubleFormatter
      extends java.lang.Object

  This class formats a double into a set of digits and an exponent for further formatting by the Double class. It is based on the same code used by Jackson and in OpenJDK with the following copyright:

  Copyright 2018-2020 Raffaello Giulietti

  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

  The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DoubleFormatter()` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Decimal` | `toDecimal​(double v)` | Convert a double to a Decimal object that may be output in various ways.
    `static java.lang.String` | `toString​(double v)` | Convert a double to String as defined in the "Number::toString" operation in ECMAScript.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DoubleFormatter

          public DoubleFormatter()

  - ### Method Detail

    - #### toString

          public static java.lang.String toString​(double v)

      Convert a double to String as defined in the "Number::toString" operation in ECMAScript. It can handle any number including non-finite numbers.

    - #### toDecimal

          public static Decimal toDecimal​(double v)

      Convert a double to a Decimal object that may be output in various ways. Unlike toString, and since it always returns a Decimal, it must be used with finite numbers only or the result is undetermined.